<?xml version="1.0" encoding="UTF-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
@author 		pedro.garcia
@description 	El mejor CC para dialogos de confirmación. Se corrigen errores chimbos
    (como el de Gabriel que usa todo un MB para el mensaje de confirmación) y se hace lo más genérico
    posible.
    Se tiene la opción de usar métodos con retorno String o void para los botones de "yes" y "no"

@version 		2.0

OJO: pilas con la combinación de los atributos que definen si se usan métodos String y las firmas de
        los métodos usados; esta debe ser correspondiente (ej: si digo useStringActionOnYes = true,
        debo usar el parámetro stringActionOnYes y el valor debe ser un método de tipo String


Note: 	Usar este componente fuera de un tag <form/> para evitar problemas de formularios anidados.

OJO: NO MODIFICAR

@modified leidy.gonzalez:: 07/06/2016::#17785:: Se agrega dialogo para visualizar que al tramite ya se le habia asignado
un digitalizador anteriormente.
@modified César Vega:: 21/04/2017#25952:: Se agrega barra de diálogo al primer botón.
-->

<html xmlns="http://www.w3.org/1999/xhtml"
      xmlns:h="http://java.sun.com/jsf/html"
      xmlns:p="http://primefaces.org/ui"
      xmlns:composite="http://java.sun.com/jsf/composite">

    <composite:interface>

        <composite:attribute name="yesLabel" default="Sí"
                             shortDescription="etiqueta del botón que acepta"/>
        <composite:attribute name="noLabel" default="No"
                             shortDescription="etiqueta del botón que rechaza"/>
        <composite:attribute name="showNoLabel" default="true"
                             shortDescription="Determina si se muestra el boton que rechaza"/>
        <composite:attribute name="headerLabel" default="Confirmación"
                             shortDescription="etiqueta de la ventana"/>

        <composite:attribute name="confirmMessage" required="true"
                             shortDescription="mensaje de confirmación que se va a mostrar"/>
        <composite:attribute name="confirmUpdateOnYes" required="false"
                             default="ultimateConfirmationDialogForm"
                             shortDescription="cadena con los ids de los componentes que se van a actualizar cuando se acepte"/>
        <composite:attribute name="confirmUpdateOnNo" required="false"
                             default="ultimateConfirmationDialogForm"
                             shortDescription="cadena con los ids de los componentes que se van a actualizar cuando se rechace"/>

        <composite:attribute name="confirmDialogWV" required="true"
                             shortDescription="nombre de widgetvar que se le va a dar a este dialog"/>

        <composite:attribute name="actionOnNoIsClose" required="false" default="true"
                             shortDescription="define que la acción por defecto en el botón de rechazar es cerrar este dialog"/>


        <composite:attribute name="useStringActionOnYes" required="false" default="false"
                             shortDescription="define si el método que se llama en el 'sí' es de tipo String. Si no, se supone que es void"/>
        <composite:attribute name="useStringActionOnNo" required="false" default="false"
                             shortDescription="define si el método que se llama en el 'no' es de tipo String. Si no, se supone que es void"/>

        <composite:attribute name="stringActionOnNo"
                             method-signature="java.lang.String action()" />
        <composite:attribute name="voidActionOnNo"
                             method-signature="void action()" />
        <composite:attribute name="stringActionOnYes"
                             method-signature="java.lang.String action()" />
        <composite:attribute name="voidActionOnYes"
                             method-signature="void action()" />
        <composite:attribute name="additionalActionOnYes" required="false"
                             shortDescription="acción adicional js que se hace en el onComplete del 'yes'. Debe ir antecedido de';'" />
        <composite:attribute name="additionalActionOnNo" required="false"
                             shortDescription="acción adicional js que se hace en el onComplete del 'no'. Debe ir antecedido de';'" />                      

        <composite:attribute name="ajaxStatusDialogWVName" required="false" default="statusDialog2"
                             shortDescription="widget var de la barra de estado ajax que se quiera usar"/>

        <composite:attribute name="width" default="400" required="false" 
                             shortDescription="ancho del cuadro de dialogo"/>

        <composite:attribute name="closable" default="true" required="false"
                             shortDescription="Define si el dialogo se puede cerrar"/>



    </composite:interface>

    <composite:implementation>
        <p:confirmDialog appendToBody="true" id="ultimateConfirmationMsg"
                         message="#{cc.attrs.confirmMessage}" closable="#{cc.attrs.closable}"
                         width="#{cc.attrs.width}"
                         header="#{cc.attrs.headerLabel}" severity="alert"
                         widgetVar="#{cc.attrs.confirmDialogWV}" 
                         styleClass="outputTextForConfirmationDialog">


            <h:form id="ultimateConfirmationDialogForm">
                <p:outputPanel layout="block" style="text-align:center">

                    <p:commandButton value="#{cc.attrs.yesLabel}" icon="ui-icon-check"
                                     rendered="#{cc.attrs.useStringActionOnYes}"
                                     update="#{cc.attrs.confirmUpdateOnYes}"
                                     action="#{cc.attrs.stringActionOnYes}"
                                     onclick="#{cc.attrs.ajaxStatusDialogWVName}.show();"
                                     oncomplete="#{cc.attrs.ajaxStatusDialogWVName}.hide(); #{cc.attrs.confirmDialogWV}.hide()"
                                     ajax="true"
                                     title="Realizar acción" />

                    <p:commandButton value="#{cc.attrs.yesLabel}" icon="ui-icon-check"
                                     rendered="#{!cc.attrs.useStringActionOnYes}"
                                     update="#{cc.attrs.confirmUpdateOnYes}"
                                     action="#{cc.attrs.voidActionOnYes}"
                                     onclick="#{cc.attrs.ajaxStatusDialogWVName}.show();"
                                     oncomplete="#{cc.attrs.ajaxStatusDialogWVName}.hide(); #{cc.attrs.confirmDialogWV}.hide();
                                     #{cc.attrs.additionalActionOnYes}"
                                     ajax="true"
                                     title="Realizar acción" />


                    <p:spacer width="10" />



                    <p:commandButton value="#{cc.attrs.noLabel}" icon="ui-icon-close"
                                     rendered="#{cc.attrs.useStringActionOnNo and 
                                                 not cc.attrs.actionOnNoIsClose and cc.attrs.showNoLabel}"
                                     update="#{cc.attrs.confirmUpdateOnNo}"
                                     action="#{cc.attrs.stringActionOnNo}"
                                     onstart="#{cc.attrs.ajaxStatusDialogWVName}.show();"
                                     oncomplete="#{cc.attrs.ajaxStatusDialogWVName}.hide(); #{cc.attrs.confirmDialogWV}.hide()"
                                     ajax="false"
                                     title="Realizar acción (String) y cerrar esta ventana de confirmación"/>

                    <p:commandButton value="#{cc.attrs.noLabel}" icon="ui-icon-close"
                                     rendered="#{!cc.attrs.useStringActionOnNo and 
                                                 not cc.attrs.actionOnNoIsClose and cc.attrs.showNoLabel}"
                                     update="#{cc.attrs.confirmUpdateOnNo}"
                                     action="#{cc.attrs.voidActionOnNo}"
                                     onstart="#{cc.attrs.ajaxStatusDialogWVName}.show();"
                                     oncomplete="#{cc.attrs.ajaxStatusDialogWVName}.hide(); #{cc.attrs.confirmDialogWV}.hide(); 
                                     #{cc.attrs.additionalActionOnNo}"
                                     ajax="true"
                                     title="Realizar acción (void) y cerrar esta ventana de confirmación"
                                     />

                    <p:commandButton value="#{cc.attrs.noLabel}" icon="ui-icon-close"
                                     rendered="#{cc.attrs.actionOnNoIsClose and cc.attrs.showNoLabel}"
                                     onclick="#{cc.attrs.confirmDialogWV}.hide();"
                                     ajax="true"
                                     title="Cerrar esta ventana de confirmación."/>

                </p:outputPanel>
            </h:form>
        </p:confirmDialog>

    </composite:implementation>

</html>